!****************************************************************************
!  DESCRIPTION...: Library for XML Export/Import
!  COPYRIGHT.....: Copyright 2003, 2013 SoftVelocity Inc. All rights reserved
!
!  Refactoring of cpxml.inc, cpxml.clw and cpxmlif.inc in 2013 by David Harms
!  with the express permission of SoftVelocity and the assistance
!  of The Descartes Systems Group Inc.
!****************************************************************************

                                            Member
                                            Map
                                            End



    Include('System_XML_AttrList.inc'),Once
    !include('System_Logger.inc'),once

!dbg                                     System_Logger

System_XML_AttrList.Construct                     Procedure()
    code
    self.AttrQ &= new System_XML_AttrQueue
    


System_XML_AttrList.Destruct                Procedure()
    code
    self.Reset()
    dispose(self.AttrQ)
    
System_XML_AttrList.AddAttr                 procedure(string name, string value)
Attr                                            &System_XML_Attr
    code
    Attr &= new System_XML_Attr
    attr.Name = name
    attr.SetValue(value)
    self.AddAttr(attr)
    
System_XML_AttrList.AddAttr                 procedure(*System_XML_Attr attr)
    code
    clear(self.AttrQ)
    self.AttrQ.attr &= attr
    self.AttrQ.Name = attr.Name
    add(self.AttrQ)
    
System_XML_AttrList.CloneFrom               procedure(*System_XML_AttrList sourceAttrList)
sourceAttr                                      &System_XML_Attr
x                                               long
    code
    self.Reset()
    loop x = 1 to sourceAttrList.GetCount()
        sourceAttr &= sourceAttrList.GetAttr(x)
        self.AddAttr(sourceAttr.Name, sourceAttr.GetValue())
    end
    
System_XML_AttrList.FindAttr                                    procedure(string name)!,*System_XML_Attr
x   long
    code
    loop x = 1 to records(self.AttrQ)
        get(self.AttrQ,x)
        if self.AttrQ.Attr.Name = name then return self.AttrQ.Attr .
    end
    return null
    

System_XML_AttrList.GetAttr                 procedure(long index)!,*System_XML_Attr
    code
    get(self.Attrq,index)
    if not errorcode() and not self.AttrQ.Attr &= null then return self.AttrQ.Attr.
    return null
        
System_XML_AttrList.GetCount                procedure!,long
    code
    return records(self.attrq)
    
System_XML_AttrList.Reset                   Procedure()
x                                               long
    code
    loop x = 1 to records(self.AttrQ)
        get(self.AttrQ,x)
        if not self.AttrQ.attr &= null
            dispose(self.AttrQ.Attr)
        end
    end
    free(self.AttrQ)




