!****************************************************************************
!  DESCRIPTION...: Library for XML Export/Import
!  COPYRIGHT.....: Copyright 2003, 2013 SoftVelocity Inc. All rights reserved
!
!  Refactoring of cpxml.inc,cpxml.clw and cpxmlif.inc in 2013 by David Harms
!  with the express permission of SoftVelocity and the assistance
!  of The Descartes Systems Group Inc.
!****************************************************************************

System_XML_CenterPoint_DOMObject            interface .;map;module('DOMObject');
AddRef                                          PROCEDURE(*System_XML_CenterPoint_DOMObject),name('_addRef@4'),pascal,raw
Duplicate                                       PROCEDURE(*System_XML_CenterPoint_DOMObject),name('_duplicate@4'),pascal,raw
Release                                         PROCEDURE(*System_XML_CenterPoint_DOMObject),name('_release@4'),pascal,raw
CountReferences                                 PROCEDURE(*System_XML_CenterPoint_DOMObject),signed,name('_countReferences@4'),pascal,raw
                                            end ; end


System_XML_CenterPoint_Node                 interface(System_XML_CenterPoint_DOMObject);end;map;module('System_XML_CenterPoint_Node')
GetNodeName                                     PROCEDURE(*System_XML_CenterPoint_Node),*CSTRING,name('_getNodeName@4'),pascal,raw
GetNodeValue                                    PROCEDURE(*System_XML_CenterPoint_Node),*CSTRING,name('_getNodeValue@4'),pascal,raw
SetNodeValue                                    PROCEDURE(*System_XML_CenterPoint_Node,const *CSTRING value),name('_setNodeValue@8'),pascal,raw
GetNodeType                                     PROCEDURE(*System_XML_CenterPoint_Node),UNSIGNED,name('_getNodeType@4'),pascal,raw
GetParentNode                                   PROCEDURE(*System_XML_CenterPoint_Node),*System_XML_CenterPoint_Node,name('_getParentNode@4'),pascal,raw
GetChildNodes                                   PROCEDURE(*System_XML_CenterPoint_Node),*System_XML_CenterPoint_NodeList,name('_getChildNodes@4'),pascal,raw
GetFirstChild                                   PROCEDURE(*System_XML_CenterPoint_Node),*System_XML_CenterPoint_Node,name('_getFirstChild@4'),pascal,raw
GetLastChild                                    PROCEDURE(*System_XML_CenterPoint_Node),*System_XML_CenterPoint_Node,name('_getLastChild@4'),pascal,raw
GetPreviousSibling                              PROCEDURE(*System_XML_CenterPoint_Node),*System_XML_CenterPoint_Node,name('_getPreviousSibling@4'),pascal,raw
GetNextSibling                                  PROCEDURE(*System_XML_CenterPoint_Node),*System_XML_CenterPoint_Node,name('_getNextSibling@4'),pascal,raw
GetAttributes                                   PROCEDURE(*System_XML_CenterPoint_Node),*System_XML_CenterPoint_NamedNodeMap,name('_getAttributes@4'),pascal,raw
GetOwnerDocument                                PROCEDURE(*System_XML_CenterPoint_Node),*System_XML_CenterPoint_Document,name('_getOwnerDocument@4'),pascal,raw
InsertBefore                                    PROCEDURE(*System_XML_CenterPoint_Node,*System_XML_CenterPoint_Node newChild,*System_XML_CenterPoint_Node refChild),*System_XML_CenterPoint_Node,proc,name('_insertBefore@12'),pascal,raw
ReplaceChild                                    PROCEDURE(*System_XML_CenterPoint_Node,*System_XML_CenterPoint_Node newChild,*System_XML_CenterPoint_Node oldChild),*System_XML_CenterPoint_Node,name('_replaceChild@12'),pascal,raw
RemoveChild                                     PROCEDURE(*System_XML_CenterPoint_Node,*System_XML_CenterPoint_Node oldChild),*System_XML_CenterPoint_Node,proc,name('_removeChild@8'),pascal,raw
AppendChild                                     PROCEDURE(*System_XML_CenterPoint_Node,*System_XML_CenterPoint_Node newChild),*System_XML_CenterPoint_Node,name('_appendChild@8'),pascal,raw,proc
HasChildNodes                                   PROCEDURE(*System_XML_CenterPoint_Node),byte,name('_hasChildNodes@4'),pascal,raw
CloneNode                                       PROCEDURE(*System_XML_CenterPoint_Node,byte deep),*System_XML_CenterPoint_Node,name('_cloneNode@8'),pascal,raw
! DOM Level 2
Normalize                                       PROCEDURE(*System_XML_CenterPoint_Node),name('_normalize@4'),pascal,raw
IsSupported                                     PROCEDURE(*System_XML_CenterPoint_Node,const *CSTRING feature,const *CSTRING version),byte,name('_isSupported@12'),pascal,raw
GetNamespaceURI                                 PROCEDURE(*System_XML_CenterPoint_Node),*CSTRING,name('_getNamespaceURI@4'),pascal,raw
GetPrefix                                       PROCEDURE(*System_XML_CenterPoint_Node),*CSTRING,name('_getPrefix@4'),pascal,raw
GetLocalName                                    PROCEDURE(*System_XML_CenterPoint_Node),*CSTRING,name('_getLocalName@4'),pascal,raw
HasAttributes                                   PROCEDURE(*System_XML_CenterPoint_Node),byte,name('_hasAttributes@4'),pascal,raw
                                            end ; end

System_XML_CenterPoint_Attr                 interface(System_XML_CenterPoint_Node) .;map;module('System_XML_CenterPoint_Attr')
GetName                                         PROCEDURE(*System_XML_CenterPoint_Attr),*CSTRING,name('_getName@4'),pascal,raw
GetSpecified                                    PROCEDURE(*System_XML_CenterPoint_Attr),byte,name('_getSpecified@4'),pascal,raw
GetValue                                        PROCEDURE(*System_XML_CenterPoint_Attr),*CSTRING,name('_getValue@4'),pascal,raw
SetValue                                        PROCEDURE(*System_XML_CenterPoint_Attr,const *CSTRING value),name('_setValue@8'),pascal,raw
GetOwnerElement                                 PROCEDURE(*System_XML_CenterPoint_Attr),*System_XML_CenterPoint_Element,name('_getOwnerElement@4'),pascal,raw
                                            end ; end

System_XML_CenterPoint_CharacterData        interface(System_XML_CenterPoint_Node) .;map;module('System_XML_CenterPoint_CharacterData')
GetData                                         PROCEDURE(*System_XML_CenterPoint_CharacterData),*CSTRING,name('_getData@4'),pascal,raw
SetData                                         PROCEDURE(*System_XML_CenterPoint_CharacterData,const *CSTRING data),name('_setData@8'),pascal,raw
GetLength                                       PROCEDURE(*System_XML_CenterPoint_CharacterData),UNSIGNED,name('_getLength@4'),pascal,raw
SubstringData                                   PROCEDURE(*System_XML_CenterPoint_CharacterData,UNSIGNED offset,UNSIGNED count),*CSTRING,name('_substringData@12'),pascal,raw
AppendData                                      PROCEDURE(*System_XML_CenterPoint_CharacterData,const *CSTRING arg),name('_appendData@8'),pascal,raw
InsertData                                      PROCEDURE(*System_XML_CenterPoint_CharacterData,UNSIGNED offset,const *CSTRING arg),name('_insertData@12'),pascal,raw
DeleteData                                      PROCEDURE(*System_XML_CenterPoint_CharacterData,UNSIGNED offset,UNSIGNED count),name('_deleteData@12'),pascal,raw
ReplaceData                                     PROCEDURE(*System_XML_CenterPoint_CharacterData,UNSIGNED offset,UNSIGNED count,const *CSTRING arg),name('_replaceData@16'),pascal,raw
                                            end ; end

System_XML_CenterPoint_Text                 interface(System_XML_CenterPoint_CharacterData) .;map;module('System_XML_CenterPoint_Text')
SplitText                                       PROCEDURE(*System_XML_CenterPoint_Text,UNSIGNED offset),*System_XML_CenterPoint_Text,name('_splitText@8'),pascal,raw
                                            end ; end



System_XML_CenterPoint_CDATASection         interface(System_XML_CenterPoint_Text)
                                            end


System_XML_CenterPoint_Comment              interface(System_XML_CenterPoint_CharacterData)
                                            end


System_XML_CenterPoint_Document             interface(System_XML_CenterPoint_Node) .;map;module('System_XML_CenterPoint_Document')
GetDoctype                                      PROCEDURE,*System_XML_CenterPoint_DocumentType,name('_getDocumentType@4'),pascal,raw
GetImplementation                               PROCEDURE,*System_XML_CenterPoint_DOMImplementation,name('_getImplementation@4'),pascal,raw
GetDocumentElement                              PROCEDURE(*System_XML_CenterPoint_Document),*System_XML_CenterPoint_Element,name('_getDocumentElement@4'),pascal,raw
CreateElement                                   PROCEDURE(*System_XML_CenterPoint_Document,const *CSTRING tagName),*System_XML_CenterPoint_Element,name('_createElement@8'),pascal,raw
CreateDocumentFragment                          PROCEDURE(*System_XML_CenterPoint_Document),*System_XML_CenterPoint_DocumentFragment,name('_createDocumentFragment@4'),pascal,raw
CreateTextNode                                  PROCEDURE(*System_XML_CenterPoint_Document,const *CSTRING data),*System_XML_CenterPoint_Text,name('_createTextNode@8'),pascal,raw
CreateComment                                   PROCEDURE(*System_XML_CenterPoint_Document,const *CSTRING data),*System_XML_CenterPoint_Comment,name('_createComment@8'),pascal,raw
CreateCDATASection                              PROCEDURE(*System_XML_CenterPoint_Document,const *CSTRING data),*System_XML_CenterPoint_CDATASection,name('_createCDATASection@8'),pascal,raw
CreateProcessingInstruction                     PROCEDURE(*System_XML_CenterPoint_Document,const *CSTRING target,const *CSTRING data),*System_XML_CenterPoint_ProcessingInstruction,name('_createProcessingInstruction@12'),pascal,raw
CreateAttribute                                 PROCEDURE(*System_XML_CenterPoint_Document,const *CSTRING name),*System_XML_CenterPoint_Attr,name('_createAttribute@8'),pascal,raw
CreateEntityReference                           PROCEDURE(*System_XML_CenterPoint_Document,const *CSTRING name),*System_XML_CenterPoint_EntityReference,name('_createEntityReference@8'),pascal,raw
GetElementsByTagName                            PROCEDURE(*System_XML_CenterPoint_Document,const *CSTRING name),*System_XML_CenterPoint_NodeList,name('_getElementsByTagName2@8'),pascal,raw
ImportNode                                      PROCEDURE(*System_XML_CenterPoint_Document,*System_XML_CenterPoint_Node importedNode,byte deep),*System_XML_CenterPoint_Node,name('_importNode@12'),pascal,raw
CreateElementNS                                 PROCEDURE(*System_XML_CenterPoint_Document,const *CSTRING namespaceURI,const *CSTRING qualifiedName),*System_XML_CenterPoint_Element,name('_createElementNS@12'),pascal,raw
CreateAttributeNS                               PROCEDURE(*System_XML_CenterPoint_Document,const *CSTRING namespaceURI,const *CSTRING qualifiedName),*System_XML_CenterPoint_Attr,name('_createAttributeNS@12'),pascal,raw
GetElementsByTagNameNS                          PROCEDURE(*System_XML_CenterPoint_Document,const *CSTRING namespaceURI,const *CSTRING localName),*System_XML_CenterPoint_NodeList,name('_getElementsByTagNameNS@12'),pascal,raw
GetElementById                                  PROCEDURE(*System_XML_CenterPoint_Document,const *CSTRING elementId),*System_XML_CenterPoint_Element,name('_getElementById@8'),pascal,raw
                                            end  ; end

System_XML_CenterPoint_DocumentFragment     interface(System_XML_CenterPoint_Node)
                                            end


System_XML_CenterPoint_DocumentType         interface(System_XML_CenterPoint_Node) .;map;module('System_XML_CenterPoint_DocumentType')
GetName                                         PROCEDURE(*System_XML_CenterPoint_DocumentType),*CSTRING,name('_getName2@4'),pascal,raw
GetEntities                                     PROCEDURE(*System_XML_CenterPoint_DocumentType),*System_XML_CenterPoint_NamedNodeMap,name('_getEntities@4'),pascal,raw
GetNotations                                    PROCEDURE(*System_XML_CenterPoint_DocumentType),*System_XML_CenterPoint_NamedNodeMap,name('_getNotations@4'),pascal,raw
! DOM Level 2
GetPublicId                                     PROCEDURE(*System_XML_CenterPoint_DocumentType),*CSTRING,name('_getPublicId2@4'),pascal,raw
GetSystemId                                     PROCEDURE(*System_XML_CenterPoint_DocumentType),*CSTRING,name('_getSystemId2@4'),pascal,raw
GetInternalSubset                               PROCEDURE(*System_XML_CenterPoint_DocumentType),*CSTRING,name('_getInternalSubset@4'),pascal,raw
                                            end ; end

System_XML_CenterPoint_DOMImplementation    interface .;map;module('System_XML_CenterPoint_DOMImplementation')
HasFeature                                      PROCEDURE(*System_XML_CenterPoint_DOMImplementation,const *CSTRING feature,const *CSTRING version),byte,name('_hasFeature@12'),pascal,raw
! DOM Level 2      
CreateDocumentType                              PROCEDURE(*System_XML_CenterPoint_DOMImplementation,const *CSTRING qualifiedName,const *CSTRING publicId,const *CSTRING systemId),*System_XML_CenterPoint_DocumentType,name('_createDocumentType@16'),pascal,raw
CreateDocument                                  PROCEDURE(*System_XML_CenterPoint_DOMImplementation,const *CSTRING namespaceURI,const *CSTRING qualifiedName,*System_XML_CenterPoint_DocumentType doctype,ULONG poolSize = 251),*System_XML_CenterPoint_Document,name('_createDocument@20'),pascal,raw
                                            end ; end

System_XML_CenterPoint_DOMWriter            interface .;map;module('System_XML_CenterPoint_DOMWriter')
SetEncoding                                     PROCEDURE(*System_XML_CenterPoint_DOMWriter,const *CSTRING encoding),name('_setEncoding@8'),pascal,raw
SetEncoding                                     PROCEDURE(*System_XML_CenterPoint_DOMWriter,const *CSTRING encoding,bool assumeISO88591),name('_setEncoding2@12'),pascal,raw
GetEncoding                                     PROCEDURE(*System_XML_CenterPoint_DOMWriter),*CSTRING,name('_getEncoding@4'),pascal,raw
GetLastEncoding                                 PROCEDURE(*System_XML_CenterPoint_DOMWriter),*CSTRING,name('_getLastEncoding@4'),pascal,raw
SetFormat                                       PROCEDURE(*System_XML_CenterPoint_DOMWriter,UNSIGNED format),name('_setFormat@8'),pascal,raw
GetFormat                                       PROCEDURE(*System_XML_CenterPoint_DOMWriter),UNSIGNED,name('_getFormat@4'),pascal,raw
SetNewLine                                      PROCEDURE(*System_XML_CenterPoint_DOMWriter,const *CSTRING newLine),name('_setNewLine@8'),pascal,raw
GetNewLine                                      PROCEDURE(*System_XML_CenterPoint_DOMWriter),*CSTRING,name('_getNewLine@4'),pascal,raw
WriteNode                                       PROCEDURE(*System_XML_CenterPoint_DOMWriter,*System_XML_CenterPoint_Node pNode),*CSTRING,name('_writeNode@8'),pascal,raw
WriteNode                                       PROCEDURE(*System_XML_CenterPoint_DOMWriter,const *CSTRING systemId,*System_XML_CenterPoint_Node pNode),byte,name('_writeNode2@12'),pascal,raw
                                            end ; end

System_XML_CenterPoint_Element              interface(System_XML_CenterPoint_Node) .;map;module('System_XML_CenterPoint_Element')
GetTagName                                      PROCEDURE(*System_XML_CenterPoint_Element),*CSTRING,name('_getTagName@4'),pascal,raw
GetAttribute                                    PROCEDURE(*System_XML_CenterPoint_Element,const *CSTRING name),*CSTRING,name('_getAttribute@8'),pascal,raw
SetAttribute                                    PROCEDURE(*System_XML_CenterPoint_Element,const *CSTRING name,const *CSTRING value),name('_setAttribute@12'),pascal,raw,proc
RemoveAttribute                                 PROCEDURE(*System_XML_CenterPoint_Element,const *CSTRING name),name('_removeAttribute@8'),pascal,raw
GetAttributeNode                                PROCEDURE(*System_XML_CenterPoint_Element,const *CSTRING name),*System_XML_CenterPoint_Attr,name('_getAttributeNode@8'),pascal,raw
SetAttributeNode                                PROCEDURE(*System_XML_CenterPoint_Element,*System_XML_CenterPoint_Attr newAttr),*System_XML_CenterPoint_Attr,name('_setAttributeNode@8'),pascal,raw,proc
RemoveAttributeNode                             PROCEDURE(*System_XML_CenterPoint_Element,*System_XML_CenterPoint_Attr oldAttr),*System_XML_CenterPoint_Attr,name('_removeAttributeNode@8'),pascal,raw
GetElementsByTagName                            PROCEDURE(*System_XML_CenterPoint_Element,const *CSTRING name),*System_XML_CenterPoint_NodeList,name('_getElementsByTagName@8'),pascal,raw
! DOM Level 2
GetAttributeNS                                  PROCEDURE(*System_XML_CenterPoint_Element,const *CSTRING namespaceURI,const *CSTRING localName),*CSTRING,name('_getAttributeNS@12'),pascal,raw
SetAttributeNS                                  PROCEDURE(*System_XML_CenterPoint_Element,const *CSTRING namespaceURI,const *CSTRING qualifiedName,const *CSTRING value),name('_setAttributeNS@16'),pascal,raw
RemoveAttributeNS                               PROCEDURE(*System_XML_CenterPoint_Element,const *CSTRING namespaceURI,const *CSTRING localName),name('_removeAttributeNS@12'),pascal,raw
GetAttributeNodeNS                              PROCEDURE(*System_XML_CenterPoint_Element,const *CSTRING namespaceURI,const *CSTRING localName),*System_XML_CenterPoint_Attr,name('_getAttributeNodeNS@12'),pascal,raw
SetAttributeNodeNS                              PROCEDURE(*System_XML_CenterPoint_Element,*System_XML_CenterPoint_Attr newAttr),*System_XML_CenterPoint_Attr,name('_setAttributeNodeNS@8')                                                      ,pascal,raw
HasAttribute                                    PROCEDURE(*System_XML_CenterPoint_Element,const *CSTRING name),byte,name('_hasAttribute@8'),pascal,raw
HasAttributeNS                                  PROCEDURE(*System_XML_CenterPoint_Element,const *CSTRING namespaceURI,const *CSTRING localName),byte,name('_hasAttributeNS@12'),pascal,raw
                                            end ; end

System_XML_CenterPoint_Entity               interface(System_XML_CenterPoint_Node) .;map;module('System_XML_CenterPoint_Entity')
GetPublicId                                     PROCEDURE(*System_XML_CenterPoint_Entity),*CSTRING,name('_getPublicId3@4'),pascal,raw
GetSystemId                                     PROCEDURE(*System_XML_CenterPoint_Entity),*CSTRING,name('_getSystemId3@4'),pascal,raw
GetNotationName                                 PROCEDURE(*System_XML_CenterPoint_Entity),*CSTRING,name('_getNotationName@4'),pascal,raw
                                            end ; end

System_XML_CenterPoint_EntityReference      interface(System_XML_CenterPoint_Node) .;map;module('System_XML_CenterPoint_EntityReference')
                                            end ; end

System_XML_CenterPoint_NodeList             interface(System_XML_CenterPoint_DOMObject).;map;module('NodeList')
Item                                            procedure(*System_XML_CenterPoint_NodeList, unsigned index), *System_XML_CenterPoint_Node, name('_item@8'), pascal, raw
GetLength                                       procedure(*System_XML_CenterPoint_NodeList), unsigned, name('_getLength2@4'), pascal, raw
                                            end                                                                                                                             ;end


System_XML_CenterPoint_NamedNodeMap         interface(System_XML_CenterPoint_DOMObject) .;map;module('System_XML_CenterPoint_NamedNodeMap')
GetNamedItem                                    PROCEDURE(*System_XML_CenterPoint_NamedNodeMap,const *CSTRING name),*System_XML_CenterPoint_Node,name('_getNamedItem@8'),pascal,raw
SetNamedItem                                    PROCEDURE(*System_XML_CenterPoint_NamedNodeMap,*System_XML_CenterPoint_Node arg),*System_XML_CenterPoint_Node,name('_setNamedItem@8'),pascal,raw
RemoveNamedItem                                 PROCEDURE(*System_XML_CenterPoint_NamedNodeMap,const *CSTRING name),*System_XML_CenterPoint_Node,name('_removeNamedItem@8'),pascal,raw
Item                                            PROCEDURE(*System_XML_CenterPoint_NamedNodeMap,UNSIGNED index),*System_XML_CenterPoint_Node,name('_item2@8'),pascal,raw
GetLength                                       PROCEDURE(*System_XML_CenterPoint_NamedNodeMap),UNSIGNED,name('_getLength3@4'),pascal,raw
! DOM Level 2
GetNamedItemNS                                  PROCEDURE(*System_XML_CenterPoint_NamedNodeMap,const *CSTRING namespaceURI,const *CSTRING localName),*System_XML_CenterPoint_Node,name('_getNamedItemNS@12'),pascal,raw
SetNamedItemNS                                  PROCEDURE(*System_XML_CenterPoint_NamedNodeMap,*System_XML_CenterPoint_Node arg),*System_XML_CenterPoint_Node,name('_setNamedItemNS@8'),pascal,raw
RemoveNamedItemNS                               PROCEDURE(*System_XML_CenterPoint_NamedNodeMap,const *CSTRING namespaceURI,const *CSTRING localName),*System_XML_CenterPoint_Node,name('_removeNamedItemNS@12'),pascal,raw
                                            end ; end

  

System_XML_CenterPoint_Notation             interface(System_XML_CenterPoint_Node) .;map;module('System_XML_CenterPoint_Notation')
GetPublicId                                     PROCEDURE,*CSTRING,name('_getPublicID@4'),pascal,raw
GetSystemId                                     PROCEDURE,*CSTRING,name('_getSystemID@4'),pascal,raw
                                            end ; end

System_XML_CenterPoint_ProcessingInstruction        interface(System_XML_CenterPoint_Node) .;map;module('System_XML_CenterPoint_ProcessingInstruction')
GetTarget                                               PROCEDURE(*System_XML_CenterPoint_ProcessingInstruction),*CSTRING,name('_getTarget@4'),pascal,raw
GetData                                                 PROCEDURE(*System_XML_CenterPoint_ProcessingInstruction),*CSTRING,name('_getData2@4'),pascal,raw
SetData                                                 PROCEDURE(*System_XML_CenterPoint_ProcessingInstruction,const *CSTRING data),name('_setData@8'),pascal,raw
                                                    end ; end


