!****************************************************************************
!  DESCRIPTION...: Library for XML Export/Import
!  COPYRIGHT.....: Copyright 2003, 2013 SoftVelocity Inc. All rights reserved
!
!  Refactoring of cpxml.inc, cpxml.clw and cpxmlif.inc in 2013 by David Harms
!  with the express permission of SoftVelocity and the assistance
!  of The Descartes Systems Group Inc.
!****************************************************************************

                                            Member
                                            Map
                                            End



    Include('System_XML_Node.inc'),Once
    include('System_Logger.inc'),once

log                                     System_Logger

System_XML_Node.Construct                     Procedure()
    code
    self.ChildNodes &= new System_XML_NodeList
    self.ChildNodes.DisposeNodes = true
    self.Attributes &= new System_XML_AttrList
    self.IsRootElement = false

System_XML_Node.Destruct                      Procedure()
    code
    self.Reset()
    dispose(self.ChildNodes)
    dispose(self.Attributes)
    self.DisposeNodeValue()
    
System_XML_Node.AddAttribute                procedure(string name,string value)
    code
    self.Attributes.AddAttr(name,value)

System_XML_Node.AddChildNode                procedure(string nodeName,long nodeType=System_XML_NodeType:Element)!,*System_XML_Node
ChildNode                                       &System_XML_Node
    code
    if self.ChildNodes &= null
        self.ChildNodes &= new System_XML_NodeList
    end
    ChildNode &= new System_XML_Node
    ChildNode.NodeType = nodeType
    ChildNode.SetNodeName(nodeName)
    self.ChildNodes.AddNode(childNode)
    return ChildNode

System_XML_Node.AddChildNode                    procedure(*System_XML_Node childNode)
    code
    self.ChildNodes.AddNode(childNode)

System_XML_Node.AppendChildNode                 PROCEDURE(*System_XML_Node newChild)
    code
    self.ChildNodes.AppendNode(newChild)
    return newChild
    
System_XML_Node.CloneFrom               procedure(System_XML_Node sourceNode)
x                                           long
sourceChildNode                             &System_XML_Node
childNode                                   &System_XML_Node
    code
    if ~sourceNode &= null
        self.NodeName = sourceNode.NodeName
        self.SetNodeValue(sourceNode.GetNodeValue())
        self.Attributes.CloneFrom(sourceNode.Attributes)
    end
    loop x = 1 to sourceNode.ChildNodes.GetCount()
        sourceChildNode &= sourceNode.ChildNodes.GetNode(x)
        childNode &= self.AddChildNode(sourceChildNode.NodeName)
        childNode.CloneFrom(sourceChildNode)
    end

System_XML_Node.DisposeNodeValue            procedure!,protected
    code
    if not self.NodeValue &= null then dispose(self.NodeValue).
   

System_XML_Node.GetAttribute                procedure(string name)!,string
attr                                            &System_XML_Attr
    code
    attr &= self.Attributes.FindAttr(name)
    if not attr &= null then return attr.GetValue().
    return ''  

    
System_XML_Node.GetFirstNode            procedure(string nodeName)!,*System_XML_Node
x                                               long
FoundNode                                   &System_XML_Node
MatchingNOde                                &System_XML_Node
    code
    if self.NodeName = nodeName 
        return self
    end
    loop x = 1 to self.ChildNodes.GetCount()
        FoundNode &= self.ChildNodes.GetNode(x)
        if not FoundNode &= null
            MatchingNode &= FoundNode.GetFirstNode(nodeName)
            if not MatchingNode &= null then return MatchingNode.
        end
    end
    return null
    
System_XML_Node.GetNodeName                 procedure!,string
    code
    return self.NodeName
    
System_XML_Node.GetNodeValue                procedure!,string
    code
    if not self.NodeValue &= null then return self.NodeValue.
    return ''


System_XML_Node.InsertBefore                PROCEDURE(*System_XML_Node newChild,*System_XML_Node refChild)!,*System_XML_Node,proc
    code
    return null
    
System_XML_Node.Reset                       procedure
    code
    self.ChildNodes.Reset()
    self.Attributes.Reset()
    self.SetNodeValue('')
    
System_XML_Node.SetAttribute                    procedure(string attributeName,string attributeValue)
    code
    self.Attributes.AddAttr(attributeName,attributeValue)

System_XML_Node.SetNodeName                     procedure(string name)
    code
    self.NodeName = clip(name)
    

System_XML_Node.SetNodeValue                procedure(string value)
    code
    self.DisposeNodeValue()
    self.NodeValue &= new cstring(len(clip(value)) + 1)
    self.NodeValue = value
    



