!****************************************************************************
!  DESCRIPTION...: Library for XML Export/Import
!  COPYRIGHT.....: Copyright 2003, 2013 SoftVelocity Inc. All rights reserved
!
!  Refactoring of cpxml.inc, cpxml.clw and cpxmlif.inc in 2013 by David Harms
!  with the express permission of SoftVelocity and the asssistance
!  of The Descartes Systems Group Inc.
!****************************************************************************

                                            Member
                                            Map
                                            End



    Include('System_XML_NodeBuffer.inc'),Once
    Include('System_Logger.inc'),Once

log                                         System_Logger


System_XML_NodeBuffer.Construct                     Procedure()
    code


System_XML_NodeBuffer.Destruct                      Procedure()
    code


System_XML_NodeBuffer.Add                           procedure!,virtual
    code

System_XML_NodeBuffer.Get                   procedure(long direction)!,long,protected
SelectedNode                                    &System_XML_Node
RecordFound                                     bool
    code
    log.write('System_XML_NodeBuffer.Get, self.NodePointer ' & self.NodePointer)
    if direction > = 0
        direction = 1
    else
        direction = -1
    end
    log.write('Direction: ' & direction)
    RecordFound = false
    self.Reset()
    if not self.nodes &= null 
        loop
            self.NodePointer += direction
            log.write('Set nodepointer to ' & self.NodePointer)
            SelectedNode &= self.Nodes.GetNode(self.NodePointer)
            if SelectedNode &= null 
                log.write('retrieved node is null')
                break 
            end
            log.write('got node ' & SelectedNode.GetNodeName())
            if self.ValidateNode(selectedNode)
                self.CloneFrom(SelectedNode)
                log.write('node ' & SelectedNode.NodeName & ' validated')
                RecordFound = true
                break
            else
                log.write('node not validated')
            end
        end
    end
    self.OnDataChanged()
    if RecordFound then return level:benign.
    return level:fatal

System_XML_NodeBuffer.Next                  procedure!,long
    code
    return self.Get(1)
    
System_XML_NodeBuffer.OnDataChanged         procedure!,virtual
    code
    
System_XML_NodeBuffer.Previous              procedure!,long
    code
    return self.Get(-1)

System_XML_NodeBuffer.Put                           procedure!,virtual
    code
    
System_XML_NodeBuffer.Set                   procedure
    code
    self.NodePointer = 0
    
System_XML_NodeBuffer.SetDataSource         procedure(System_XML_NodeList nodeList)!,virtual
    code
    self.Nodes &= nodeList
    ! Default to the first record, if available
    self.Set()
    self.Next()
    
System_XML_NodeBuffer.SetDataSourceToChildNodesOf   procedure(System_XML_Node node)!,virtual
    code
    log.write('System_XML_NodeBuffer.SetDataSourceToChildNodesOf ' & node.NodeName & ' with ' & node.ChildNodes.GetCount() & ' child nodes')
    self.SetDataSource(node.ChildNodes)

System_XML_NodeBuffer.ValidateNode          procedure(System_XML_Node node)!,bool,virtual
    code
    return true
