!****************************************************************************
!  DESCRIPTION...: Library for XML Export/Import
!  COPYRIGHT.....: Copyright 2003, 2013 SoftVelocity Inc. All rights reserved
!
!  Refactoring of cpxml.inc, cpxml.clw and cpxmlif.inc in 2013 by David Harms
!  with the express permission of SoftVelocity and the assistance
!  of The Descartes Systems Group Inc.
!****************************************************************************

                                            Member
                                            Map
                                            End



    Include('System_XML_NodeList.inc'),Once
    include('System_Logger.inc'),once

!log                                     System_Logger

System_XML_NodeList.Construct                     Procedure()
    code
    self.NodeQ &= new System_XML_NodeQueue
    self.DisposeNodes = false


System_XML_NodeList.Destruct                Procedure()
    code
    self.Reset()
    dispose(self.NodeQ)
    
System_XML_NodeList.AddNode                 procedure(*System_XML_Node node)
    code
    if self.NodeQ &= null then stop('null').
    clear(self.NodeQ)
    self.NodeQ.Node &= node
    self.NodeQ.Name = node.NodeName
    add(self.NodeQ)
    
System_XML_NodeList.AppendNode                 procedure(*System_XML_Node node)
    code
    self.RemoveNode(node)
    self.AddNode(node)
   
System_XML_NodeList.GetCount                procedure!,long
    code
    return records(self.NodeQ)
    
System_XML_NodeList.GetNode                 procedure(long index)!,System_XML_Node
    code
    get(self.NodeQ,index)
    if not errorcode() and not self.NodeQ.Node &= null then return self.NodeQ.Node.
    return null

System_XML_NodeList.RemoveNode              procedure(*System_XML_Node node)
x                                               long
    code
    loop x = 1 to records(self.NodeQ)
        get(self.NodeQ,x)
        if self.NodeQ.node.NodeName = node.NodeName
            dispose(self.NodeQ.Node)
            delete(self.NodeQ)
            break
        end
    end


System_XML_NodeList.Reset                   procedure
x                                               long
    code
    loop x = 1 to records(self.NodeQ)
        get(self.NodeQ,x)
        if self.DisposeNodes
            dispose(self.NodeQ.Node)
        else
            self.NodeQ.Node &= null
        end
    end
    free(self.NodeQ)




